/* Author: Denis Podgurskii */

import { ptk_settings } from "./background/settings.js"
import { ptk_recorder } from "./background/recorder.js"
import { ptk_request } from "./background/request.js"
import { ptk_integration } from "./background/integration.js"

export class app {
    constructor(settings) {
        this.settings = new ptk_settings(settings)

        this.recorder = new ptk_recorder(settings.recorder)
        this.recorder.addMessageListeners()

        this.request = new ptk_request(settings.rbuilder)
        this.request.addMessageListeners()

        this.integration = []
        if (this.settings.integration) {
            Object.keys(this.settings.integration).forEach((key) => {
                let s = this.settings.integration[key]
                if (s.enable) {
                    this.integration[key] = new ptk_integration(s.content, s.channel)
                }
            })
        }
    }
}

