/* Author: Denis Podgurskii */

import { ptk_utils } from './utils.js'

export class ptk_integration {
    constructor(path, channel) {
        this.path = path
        this.channel = channel
        this.addListiners()
    }

    /* Listeners */

    addListiners() {
        this.onUpdated = this.onUpdated.bind(this)
        browser.tabs.onUpdated.addListener(this.onUpdated)
    }

    removeListiners() {
        browser.tabs.onUpdated.removeListener(this.onUpdated)
    }

    onUpdated(tabId, info, tab) {
        if (info.status != "complete" || window.ptk_recorder_active || ptk_utils.exclude(tab.url)) return
        browser.tabs.executeScript(tabId, { file: this.path, matchAboutBlank: true, allFrames: false, runAt: "document_start" }).catch(e => e)
    }
}


